image:
  name: hashicorp/terraform:light
  entrypoint:
    - '/usr/bin/env'
    - 'PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin'
    - 'AWS_SECRET_ACCESS_KEY=${AWS_SECRET_ACCESS_KEY}'
    - 'AWS_ACCESS_KEY_ID=${AWS_ACCESS_KEY_ID}'
    - 'AWS_DEFAULT_REGION=${AWS_DEFAULT_REGION}'

variables:
  PLAN: plan.tfplan

cache:
    paths:
      - iac

before_script:
  - cd iac
  - ls
  - terraform --version
  - terraform init

stages:
  - compile
  - validate
  - plan
  - apply
  - destroy

compile:
  stage: compile
  script:
    - apk add zip
    - cd ../api && zip ../iac/code.zip Latam.py pickle_model.pkl

validate:
  stage: validate
  script:
    - terraform validate
  only:
    - branches

build:
  stage: plan
  script:
    - terraform plan -out=$PLAN
  artifacts:
    name: plan
    paths:
      - $PLAN
  only:
    - branches

apply:
  stage: apply
  script:
    - terraform apply -input=false $PLAN
  dependencies:
    - build
  when: manual
  only:
    - branches

destroy:
  stage: destroy
  script:
    - echo "Destroying resources"
    - terraform destroy -state=$STATE --auto-approve
  dependencies:
    - apply
  when: manual
  only:
    refs:
      - master